using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MagniMan
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Timer timClose;
		private System.Windows.Forms.Timer timFade;
		private System.Windows.Forms.NotifyIcon notifyIcon;
		private System.Windows.Forms.ContextMenu contextMenu;
		private System.Windows.Forms.MenuItem menuItemClose;
		private System.Windows.Forms.MenuItem menuItemSetHot;
		private System.Windows.Forms.MenuItem menuItem2;
		private MouseHook myHook;

		public MainForm()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			myHook = new MouseHook();
			myHook.OnMouseActivity += new MouseEventHandler(myHook_OnMouseActivity);
			SetStartPoint() ;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		


		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.timClose = new System.Windows.Forms.Timer(this.components);
			this.notifyIcon = new System.Windows.Forms.NotifyIcon(this.components);
			this.contextMenu = new System.Windows.Forms.ContextMenu();
			this.menuItemSetHot = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItemClose = new System.Windows.Forms.MenuItem();
			this.timFade = new System.Windows.Forms.Timer(this.components);
			// 
			// timer1
			// 
			this.timer1.Enabled = true;
			this.timer1.Interval = 250;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// timClose
			// 
			this.timClose.Enabled = true;
			this.timClose.Interval = 200;
			this.timClose.Tick += new System.EventHandler(this.timClose_Tick);
			// 
			// notifyIcon
			// 
			this.notifyIcon.ContextMenu = this.contextMenu;
			this.notifyIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon.Icon")));
			this.notifyIcon.Text = "Tolle Lupe";
			this.notifyIcon.Visible = true;
			this.notifyIcon.MouseDown += new System.Windows.Forms.MouseEventHandler(this.notifyIcon_MouseDown);
			// 
			// contextMenu
			// 
			this.contextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuItemSetHot,
																						this.menuItem2,
																						this.menuItemClose});
			// 
			// menuItemSetHot
			// 
			this.menuItemSetHot.Index = 0;
			this.menuItemSetHot.Text = "Set Hotkey";
			this.menuItemSetHot.Visible = false;
			this.menuItemSetHot.Click += new System.EventHandler(this.menuItemSetHot_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "-";
			this.menuItem2.Visible = false;
			// 
			// menuItemClose
			// 
			this.menuItemClose.Index = 2;
			this.menuItemClose.Text = "Close";
			this.menuItemClose.Click += new System.EventHandler(this.menuItemClose_Click);
			// 
			// timFade
			// 
			this.timFade.Interval = 10;
			this.timFade.Tick += new System.EventHandler(this.timFade_Tick);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.WhiteSmoke;
			this.ClientSize = new System.Drawing.Size(200, 150);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Opacity = 0.8;
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "MagniMan";
			this.TopMost = true;
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.MainForm_MouseDown);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.MainForm_MouseUp);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.MainForm_Paint);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.MainForm_MouseMove);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		
		double maxOpacity = 0.8 ;
		Point mousePos ;

		bool mouseFollow = true ;
		bool MouseFollow
		{
			get
			{
				return mouseFollow ;
			}
			set
			{
				if(value)
				{
					SetStartPoint() ;
				}
				mouseFollow = value ;
			}
		}


		Image myImage ;
		Image MyImage
		{
			get
			{
				return myImage ;
			}
			set
			{
				myImage = value ;
				this.Refresh() ;
				myImage.Dispose() ;
				myImage = null ;
			}
		}

		void SetStartPoint()
		{
			Point pt = new Point( 0 , 0 ) ;
			Win32.GetCursorPos( ref pt ) ;
			this.Location = newLocation( pt ) ;
			mousePos = pt ;
		}

		void myHook_OnMouseActivity( object sender , MouseEventArgs e )
		{
			if( MouseFollow )
			{
				this.Location = newLocation( new Point( e.X , e.Y ) ) ;
			}
			if( fadeIn )
			{
				this.TopMost = true ;
			}
			mousePos = new Point( e.X , e.Y ) ;
			CaptureScreen() ;
		}

		public void CaptureScreen()
		{
			int hdcSrc = User32.GetWindowDC( User32.GetDesktopWindow()) ;
			int hdcDest = GDI32.CreateCompatibleDC( hdcSrc ) ;
			int hdcDest2 = GDI32.CreateCompatibleDC( hdcDest ) ;
			int hBitmap = GDI32.CreateCompatibleBitmap( hdcSrc , this.Width , this.Height ) ;

			int xSrc = mousePos.X - ( this.Width / 4 ) ;
			if( xSrc < 0 )
			{
				xSrc = 0 ;
			}
			if( xSrc > Screen.PrimaryScreen.Bounds.Width - ( this.Width / 2 ) )
			{
				xSrc = Screen.PrimaryScreen.Bounds.Width - ( this.Width / 2 ) ;
			}

			int ySrc = mousePos.Y - ( this.Height / 4 ) ;
			if( ySrc < 0 )
			{
				ySrc = 0 ;
			}
			if( ySrc > Screen.PrimaryScreen.Bounds.Height - ( this.Height / 2 ) )
			{
				ySrc = Screen.PrimaryScreen.Bounds.Height - ( this.Height / 2 ) ;
			}

			GDI32.SelectObject( hdcDest , hBitmap ) ;
			GDI32.StretchBlt( hdcDest , 0 , 0 , this.Width , this.Height , hdcSrc , xSrc , ySrc , this.Width / 2 , this.Height / 2 , 0x00CC0020 ) ;
			MyImage = Image.FromHbitmap( new IntPtr( hBitmap ) ) ;

			Cleanup(hBitmap,hdcSrc,hdcDest);
		}

		private void Cleanup(int hBitmap,int hdcSrc,int hdcDest)
		{
			User32.ReleaseDC(User32.GetDesktopWindow(),hdcSrc);
			GDI32.DeleteDC(hdcDest);
			GDI32.DeleteObject(hBitmap);
		}   

		int dirChange = 0 ;
		bool rechts = false ;
		private Point newLocation( Point pt )
		{
			int plusX = 5 ;
			int plusY = 5 ;
			Point newPt = new Point( pt.X + plusX , pt.Y + plusY ) ;

			if( newPt.X > this.Location.X && !rechts )
			{
				dirChange++ ;
				rechts = !rechts ;
			}
			if( newPt.X < this.Location.X && rechts )
			{
				dirChange++ ;
				rechts = !rechts ;
			}
			if( dirChange > 2 )
			{
				FadeOut() ;
			}
			
			if( pt.X <= 0 )
			{
				newPt.X = plusX ;
			}
			if( pt.Y <= 0 )
			{
				newPt.Y = plusY ;
			}
			if( pt.X + plusX > Screen.PrimaryScreen.Bounds.Width - this.Width - plusX )
			{
				if( pt.Y + plusY > Screen.PrimaryScreen.Bounds.Height - this.Height - plusY )
				{
					if( pt.X > Screen.PrimaryScreen.Bounds.Width - 2 )
					{
						newPt.X = Screen.PrimaryScreen.Bounds.Width - this.Width - plusX ;
					}
					else
					{
						newPt.X = pt.X - this.Width - plusX ;
					}
				}
				else
				{
					newPt.X = Screen.PrimaryScreen.Bounds.Width - this.Width - plusX ;
				}
			}
			
			if( pt.Y + plusY > Screen.PrimaryScreen.Bounds.Height - this.Height - plusY )
			{
				newPt.Y = Screen.PrimaryScreen.Bounds.Height - this.Height - plusY ;
			}
			return newPt ;
		}

		private void MainForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics ;
			if( MyImage != null )
			{
				g.DrawImage( MyImage , 0 , 0 ) ;
			}
			g.DrawRectangle( Pens.Gray , 0 , 0 , this.Width - 1 , this.Height - 1 ) ;
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			CaptureScreen() ;
		}

		private void timClose_Tick(object sender, System.EventArgs e)
		{
			dirChange = 0 ;
		}

		private void notifyIcon_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if( e.Button == MouseButtons.Left )
			{
				Fade() ;
			}
			if( e.Button == MouseButtons.Right )
			{
				FadeOut() ;
			}
		}

		bool fadeIn = true ;

		private void Fade()
		{
			if( fadeIn )
			{
				FadeOut() ;
				}
			else
			{
				FadeIn() ;
			}
		}

		private void FadeIn()
		{
			SetStartPoint() ;

			this.Visible = true ;
			fadeIn = true ;
			myHook.Start() ;
			timFade.Start() ;
		}

		private void FadeOut()
		{
			fadeIn = false ;
			timFade.Start() ;
		}

		private void timFade_Tick(object sender, System.EventArgs e)
		{
			if( fadeIn )
			{
				this.Opacity += 0.01 ;
			}
			else
			{
				this.Opacity -= 0.01 ;
			}
			if( this.Opacity >= maxOpacity )
			{
				timFade.Stop() ;
			}
			if( this.Opacity <= 0 )
			{
				timFade.Stop() ;
				this.Visible = false ;
				myHook.Stop() ;
			}
		}

		private void menuItemClose_Click(object sender, System.EventArgs e)
		{
			this.Close() ;
		}

		private void menuItemSetHot_Click(object sender, System.EventArgs e)
		{
			SetHotKeyForm setHotKeyForm = new SetHotKeyForm() ;
			setHotKeyForm.ShowDialog( this ) ;
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			User32.RegisterHotKey( this.Handle , 100 , User32.KeyModifiers.Control | User32.KeyModifiers.Shift , Keys.OemBackslash ) ;
			User32.RegisterHotKey( this.Handle , 101 , User32.KeyModifiers.Control | User32.KeyModifiers.Shift , Keys.Y ) ;
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			User32.UnregisterHotKey( this.Handle , 100 ) ;
			User32.UnregisterHotKey( this.Handle , 101 ) ;
			myHook.Stop() ;
		}

		protected override void WndProc( ref Message m )
		{    
			const int WM_HOTKEY = 0x0312;     
    
			switch(m.Msg)    
			{    
				case WM_HOTKEY:
					switch( (int) m.WParam)    
					{    
						case 100:
							Fade() ;
						break ;
						case 101:
							MouseFollow = !MouseFollow ;
						break ;
					}
				break;    
			}     
			base.WndProc(ref m );
		}

		int clientMouseX = 0 ;
		int clientMouseY = 0 ;
		private void MainForm_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if( e.Button == MouseButtons.Right )
			{
				Cursor = Cursors.SizeAll ;
				this.Width += e.X - clientMouseX ;
				this.Height += e.Y - clientMouseY ;
				clientMouseX = e.X ;
				clientMouseY = e.Y ;
			}
		}

		private void MainForm_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			clientMouseX = e.X ;
			clientMouseY = e.Y ;
		}

		private void MainForm_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if( e.Button == MouseButtons.Left )
			{
				MouseFollow = true ;
			}
			else
			{
				Cursor = Cursors.Default ;
			}
		}

	}
}
