using System;
using System.Drawing ;
using System.Runtime.InteropServices;
using System.Windows.Forms ;

namespace MagniMan
{
	/// <summary>
	/// Zusammenfassung fr Win32.
	/// </summary>
	public class Win32
	{
		[DllImport("user32")]
		public static extern int GetCursorPos( ref Point lpPoint ) ;

		[DllImport("user32")]
		public static extern int GetCaretPos( ref Point lpPoint ) ;
		
	}

	public class GDI32
	{
		[DllImport("GDI32.dll")]
		public static extern int StretchBlt(int hDC, int x, int y, int nWidth, int nHeight, int hSrcDC, int xSrc, int ySrc, int nSrcWidth, int nSrcHeight, int dwRop) ;
		
		[DllImport("GDI32.dll")]
		public static extern bool BitBlt(int hdcDest,int nXDest,int nYDest,int nWidth,int nHeight,int hdcSrc,int nXSrc,int nYSrc,int dwRop);
		
		[DllImport("GDI32.dll")]
		public static extern int CreateCompatibleBitmap(int hdc,int nWidth,	int nHeight);

		[DllImport("GDI32.dll")]
		public static extern int CreateCompatibleDC(int hdc);

		[DllImport("GDI32.dll")]
		public static extern bool DeleteDC(int hdc);

		[DllImport("GDI32.dll")]
		public static extern bool DeleteObject(int hObject);

		[DllImport("GDI32.dll")]
		public static extern int GetDeviceCaps(int hdc,int nIndex);

		[DllImport("GDI32.dll")]
		public static extern int SelectObject(int hdc,int hgdiobj);
 
	}

	public class User32
	{
		[DllImport("User32.dll")]
		public static extern int GetDesktopWindow() ;

		[DllImport("User32.dll")]
		public static extern int GetWindowDC( int hWnd ) ;

		[DllImport("User32.dll")]
		public static extern int ReleaseDC( int hWnd , int hDC ) ;

		public enum KeyModifiers
		{  
			None = 0,
			Alt = 1,    
			Control = 2,    
			Shift = 4,    
			Windows = 8
		}

		[DllImport("user32.dll", SetLastError=true)]
		public static extern bool RegisterHotKey( 
			IntPtr hWnd ,				// Handle fr das Fenster
			int id ,					// hot key identifier    
			KeyModifiers fsModifiers ,	// key-modifier options    
			Keys vk						// virtual-key code    
		) ; 

		[DllImport("user32.dll")]
		public static extern bool UnregisterHotKey(IntPtr hWnd,int id);
	}


}
